/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.sun.v3.sampleapplications;

import javax.ejb.Stateless;
import java.sql.Connection;
import javax.naming.InitialContext;
import javax.sql.DataSource;
import java.sql.Statement;

/**
 *
 * @author marina vatkina
 */

@Stateless
public class MyBean implements BeanLocal {

    DataSource db1 = null;
    DataSource db2 = null;

    /** 
    * Simple test
    */
    public String getString() {
        return "Hello MyBean";
    }

    public String testInsert(Connection c1, Connection c2) {
        return execute("insert into customer values (1, 'FOO')", c1, c2);
    }

    public String testInsert() {
        return execute("insert into customer values (1, 'FOO')", null, null);
    }

   private String execute(String st, Connection c10, Connection c20) {

     Connection c1 = null;
     Connection c2 = null;
     Statement stmt1 = null;
     Statement stmt2 = null;

     try {
        if (c10 == null) {
            InitialContext ic = new InitialContext();
            db1 = (DataSource)ic.lookup("jdbc/__default");
            c1 = db1.getConnection();
        } else {
            c1 = c10;
        }

        if (c20 == null) {
            InitialContext ic = new InitialContext();
            db2 = (DataSource)ic.lookup("jdbc/other");
            c2 = db2.getConnection();
        } else {
            c2 = c20;
        }

        stmt1 = c1.createStatement();
        stmt2 = c2.createStatement();

        stmt1.execute(st);
        stmt2.execute(st);

        
     } catch (Exception e){
        e.printStackTrace();
        return "NOT OK" + e.getMessage();
     }finally{

        if(stmt1 != null){
            try{
                stmt1.close();
            }catch(Exception e){}
        }


        if(stmt2 != null){
            try{
                stmt2.close();
            }catch(Exception e){}
        }

        if(c10 == null && c1 != null){
            try{
                c1.close();
            }catch(Exception e){}
        }

        if(c20 == null && c2 != null){
            try{
                c2.close();
            }catch(Exception e){}
        }
     }
     return "OK";
    }

    public String testDelete() {
        return execute("delete from customer", null, null);
    }

    public String testDelete(Connection c1, Connection c2) {
        return execute("delete from customer", c1, c2);
    }
}
