/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.sun.v3.sampleapplications;

import java.io.*;
import java.net.*;

import javax.naming.InitialContext;
import javax.servlet.*;
import javax.ejb.*;
import javax.servlet.http.*;

import java.sql.Connection;
import javax.naming.InitialContext;
import javax.sql.DataSource;

/**
 *
 * @author mvatkina
 */

public class MyServlet extends HttpServlet {

    @EJB
    BeanLocal bean;

    /** 
    * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        Connection c1 = null;
        Connection c2 = null;

        try {
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet MyServlet</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<h3>Testing MyServlet calling MyBean using JPA</h3>");
            out.println("<br>");

            // Simple test first
            String result = bean.getString();
            out.println("<h3>Simple test result: " + result + "</h3>");
            out.println("<br>");

            out.println("Inserting a row with acquired connections ... " + bean.testInsert());
            out.println("<br>");

            System.err.println("++++++++ SLEEP +++++++++++++++");
            Thread.sleep(10000);
            System.err.println("++++++++ GO +++++++++++++++");

            out.println("Removing a row  with acquired connections ... " + bean.testDelete());
            out.println("<br>");

            InitialContext ic = new InitialContext();
            DataSource derby = (DataSource)ic.lookup("jdbc/__default");
            DataSource db2 = (DataSource)ic.lookup("jdbc/other");

            c1 = derby.getConnection();
            c2 = db2.getConnection();

            out.println("Inserting a row with provided connections ... " + bean.testInsert(c1, c2));
            out.println("<br>");

            System.err.println("++++++++ SLEEP +++++++++++++++");
            Thread.sleep(10000);
            System.err.println("++++++++ GO +++++++++++++++");

            out.println("Removing a row  with provided connections ... " + bean.testDelete(c1, c2));
            out.println("<br>");

        }catch(Throwable e){
            out.println("got outer excpetion");
            out.println(e);
            e.printStackTrace();
        }
        finally {
            if(c1 != null){
                try{
                    c1.close();
                }catch(Exception e){}
            }

            if(c2 != null){
                try{
                    c2.close();
                }catch(Exception e){}
            }

               out.println("finally");

            out.println("</body>");
            out.println("</html>");
            
            out.close();
            out.flush();

        }
    }


    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
